jQuery(function ($) {

    /**RUN ADS**/
    jQuery(document).ready(function () { //Verify that document is complete
        if (typeof sssp.getAdsByTags === "function" && typeof sssp_get_breakpoint === "function") {
            if (window.innerWidth <= sssp_get_breakpoint()) { //Check if the windows is lower or equal to breakpoint
                jQuery.when(jQuery('.sssp-seznam-ad-desktop').remove()).then(sssp.getAdsByTags()); //Remove desktop ADS
            } else {
                jQuery.when(jQuery('.sssp-seznam-ad-mobile').remove()).then(sssp.getAdsByTags()); //Remove mobile ADS
            }
        } else {
            //Just let now to the console that something is wrong (for debug purposes)
            console.warn('sssp.getAdsByTags() or sssp_get_breakpoint() is not a function!');
        }
    });

    /**ReloadADS Debug Tool**/
    jQuery(document).on("click", '#sssp-reload-ads', function () {
        jQuery('.sssp-posCont').remove();
        sssp.getAdsByTags();
    });

    /**POPUP**/
    jQuery(document).ready(function () {
        var popup_div = jQuery('#ssspShowPopUp');
        var popup_zone_id_m = popup_div.data('zoneidm');
        var popup_zone_id_d = popup_div.data('zoneidd');
        var breakpoint = popup_div.data('width');
        //var mz_status = popup_div.data('mz');
        var nf = popup_div.data('nf') == '1';

        var params = [];

        if (popup_zone_id_d !== undefined) {
            params.push({
                type: "desktop",
                zoneId: popup_zone_id_d,
                breakPoint: 768,
                fromFeed: nf,
                onScrollElementId: popup_div.attr("id")
            });
        }

        if (popup_zone_id_m !== undefined) {
            params.push({
                type: "mobile",
                zoneId: popup_zone_id_m,
                breakPoint: breakpoint,
                fromFeed: nf,
                onScrollElementId: popup_div.attr("id")
            });
        }

        window.getSznAdPopUp(params);
    });

    /**
     * This part of code just remove all other sticky widgets if there are any.
     * It must leave only last child. If not the calculations of positions will be mismatched
     * Sticky Widget
     */
    jQuery(document).ready(function () {

        jQuery('.sssp-sticky-box').each(function () {
            if (jQuery(this).is(":last-child")) {

            } else {
                jQuery(this).removeClass('sssp-sticky-box');
                jQuery('[id="sssp-breakpoint"]:not(#sssp-breakpoint:last)').remove();
            }
        }).promise().done(function () {
            var sticky_box = jQuery('.sssp-sticky-box');
            var sticky_box_id = jQuery('.sssp-sticky-box').attr('id');
            if (sticky_box.length) {
                sssp_sticky('sssp-breakpoint', sticky_box_id);
            }

        });

    });

    /**
     * @param breakPoint
     * @param onScrollElementId
     */
    function sssp_sticky(breakPoint, onScrollElementId) {
        if (window.innerWidth >= 1365) {

            //start time
            var sticky_start_time = jQuery.now();

            //Basic variables before start
            var scrolling_element = jQuery('#' + onScrollElementId + ':last-child'); //On Scroll Widget
            var desktop_class = scrolling_element.hasClass('sssp-seznam-ad-desktop'); //Verify that ad is for a desktop

            var breakpoint_offset = jQuery('#' + breakPoint).offset(); //Breakpoint offset

            if (scrolling_element && desktop_class) {

                //Scrolling element info
                var scrolling_element_width = scrolling_element.outerWidth();
                var scrolling_element_height = scrolling_element.outerHeight();
                var scrolling_element_offset = scrolling_element.offset();

                //Last element info
                var last_element_id = sssp_get_the_last_element_id();
                var last_element_height = jQuery('#' + last_element_id).outerHeight(); //comments section height
                var last_element_offset = jQuery('#' + last_element_id).offset(); //Offset of the div on the end of content

                //Add scrolling element basic CSS
                scrolling_element.css({'width': scrolling_element_width, 'box-sizing': 'border-box', 'position': 'static'});

                if (last_element_id && last_element_offset.top + last_element_height > scrolling_element_offset.top + scrolling_element_height) { //Verify that scrolling is even possible before make you element sticky

                    var widget_id = scrolling_element.find('.sssp-seznam-ad-desktop').data('ssp-ad-id');
                    var sssp_flag_one = true;
                    var sssp_flag_two = false;
                    var sssp_flag_three = false;

                    //Scrolling element offset
                    var left_element_postition = breakpoint_offset.left; //Return ofsset.left value. Reason: If parent element is in Relative position it return wrong left position. So keep it in variable.


                    jQuery(window).scroll(function () {

                        var sticky_current_time = jQuery.now();
                        var breakpoint_offset = jQuery('#' + breakPoint).offset(); //Breakpoint offset
                        var window_top = jQuery(window).scrollTop();
                        var last_element_offset = jQuery('#' + last_element_id).offset(); //Offset of the div on the end of content
                        var offset = 15;
                        var scrolling_element_height = scrolling_element.outerHeight()+offset; //Scrolling element height
                        var last_element_height = jQuery('#' + last_element_id).outerHeight(); //comments section height

                        var top_scroll_offset = jQuery('#' + last_element_id).offset().top - scrolling_element_height + last_element_height - window_top;


                        //Set the end of the element for sticky position
                        var end_offset_status = window_top >= last_element_offset.top - scrolling_element_height - offset + last_element_height;

                        //Just set basic non-sticky statement
                        var ssspsticky = false;

                        //Set basic left offset. It is important for the right position sticky element
                        scrolling_element.css({'left': scrolling_element_offset.left, 'position': 'fixed'});

                        console.log();

                        //This part is responsible for hiding the Sticky widget. It is actually not remove stickyness, just set visibility to hidden.
                        if (scrolling_element_offset && last_element_offset) { //Verify that both parameters are on the page before you start make sticky

                            if (breakpoint_offset.top < window_top && last_element_offset.top > scrolling_element_offset.top) {

                                ssspsticky = true;
                                if (end_offset_status) { //IF Element reach the end
                                    scrolling_element.removeClass('sssp-sticky');
                                    scrolling_element.css({'top': top_scroll_offset, 'left': + left_element_postition});
                                    ssspsticky = false;
                                } else {
                                    scrolling_element.addClass('sssp-sticky');
                                    scrolling_element.css({'top': '', 'left': + left_element_postition});
                                    ssspsticky = true;
                                }
                            }else {
                                //IF Element reach the end
                                scrolling_element.removeClass('sssp-sticky').css({'position': 'static'});
                                scrolling_element.css({'top': '', 'left': + left_element_postition});
                                ssspsticky = false;
                            }
                        }

                        //Remove sticky if is resized window
                        jQuery(window).resize(function () {
                            if (ssspsticky === true) {
                                scrolling_element.removeClass('sssp-sticky').css({'position': 'static', 'left': ''});
                                left_element_postition = jQuery('#' + breakPoint).offset().left; // Return ofsset.left value if windows is resized. Reason: If parent element is in Relative position it return wrong numbers.
                            }
                        });

                        //This part is only or refreshing the ads after 6000 ms and 3000pixels
                        //Refresh the ads
                        if (ssspsticky === true && !end_offset_status && (sssp_flag_one === true || sssp_flag_two === true || sssp_flag_three === true)) {
                            var widget_object = scrolling_element.find('.sssp-seznam-ad-desktop').data('ssp-ad-object');
                            var adOffset = jQuery('#' + widget_id).outerHeight();

                            //Variables for refresh
                            var sssp_max_document_height = 3000;
                            var sssp_time_delay = 6000;

                            var sssp_widget_element = jQuery('#' + widget_id);
                            var sssp_widget_offset = sssp_widget_element.offset().top;

                            if (sssp_widget_offset > sssp_max_document_height - adOffset &&
                                sticky_start_time + sssp_time_delay < sticky_current_time &&
                                sssp_flag_one === true) {
                                jQuery.when(sssp_widget_element.removeAttr('style').find('.sssp-posCont').remove()).then(sssp.getAds(widget_object));
                                sssp_flag_one = false;
                                sssp_flag_two = true;
                                sticky_start_time = jQuery.now();
                            } else if (
                                sssp_widget_offset > sssp_max_document_height * 2 - adOffset &&
                                sticky_start_time + sssp_time_delay + sssp_time_delay < sticky_current_time &&
                                sssp_flag_two === true &&
                                sssp_flag_one === false) {
                                jQuery.when(sssp_widget_element.removeAttr('style').find('.sssp-posCont').remove()).then(sssp.getAds(widget_object));
                                sssp_flag_two = false;
                                sssp_flag_three = true;
                                sticky_start_time = jQuery.now();
                            } else if (
                                sssp_widget_offset > sssp_max_document_height * 3 - adOffset &&
                                sticky_start_time + sssp_time_delay + sssp_time_delay < sticky_current_time &&
                                sssp_flag_three === true &&
                                sssp_flag_two === false) {
                                jQuery.when(sssp_widget_element.removeAttr('style').find('.sssp-posCont').remove()).then(sssp.getAds(widget_object));
                                sssp_flag_three = false;
                                sticky_start_time = jQuery.now();
                            }
                        }

                    });
                }
            }

            /**
             * Last element ID
             * @returns {string|boolean}
             */
            function sssp_get_the_last_element_id() {
                if (jQuery('#sssp-sticky-end').length > 0) { //<div id="sssp-sticky-end"></div>
                    return ('sssp-sticky-end');
                } else {
                    if (jQuery('#comments').length > 0) {
                        return ('comments');
                    } else if (jQuery('#sdop-below-article-box').length > 0) {
                        return ('sdop-below-article-box');
                    } else if (jQuery('#sssp-content-end').length > 0) {
                        return ('sssp-content-end');
                    }else{
                        return false;
                    }
                }
            }
        }
    }

});
